//+------------------------------------------------------------------+
//|                                                   CrossingMA.mq4 |
//|                                                           AndYac |
//|                                          http://www.andyac.nm.ru |
//+------------------------------------------------------------------+
#property copyright "Tiser"
#property link      "http://www.andyac.nm.ru"

//-  D1
/*
.  www.finlist.ru

     " ",         .     ,      ,    ,    ,      ,    -  . .    ,       10    ,   ,     . 

      .     . 
 -    . 
  -  ,  3   ( ) +3 
    -     +5 . (  ),   L -5  (  ) 
    -     +5 . 
    -     L -5  
      . 
       ,    (  ,   ) 
       -(+) 5 .   .      ,                 .         . 
  ,    ,    . (   ,    , ,      ) 

  : 

1.      . 
2.               -    ,   -  . 
3.         ,   .      ,   5 . 
4.       ,            ( ()  3 ),        . 
5.        ,   ,     ,  ,  .     -         . 
6.  10 .       
*/





//---- input parameters

extern double     Lots           = 1;      //   
extern double     TakeProfit     = 0;      //  
extern double     StopLoss       = 0;      //  
extern double     PeriodMA       = 3;      //  
extern double     ShiftMA        = 3;      //     
extern int        Bar_count      = 3;      //        +5
extern int        PointInPlus    = 5;      //         /
extern int        PointInMinus   = 0;      //     
extern int        Bars_stop_Count= 2;      //     N 
extern bool       take5p         = true;   //  -     +5
extern int    Magic          = 78913;      //      

int buy_sell_stop, buy_sell; //       
int x;      //  
double y;      //  
datetime LastDay = 0; //       1   


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   int pos_1, total_1; //    (  ,  )
  
  
   //   
   if(Bars<20)
     {
      Print(",   ,  100 ");
      return(0);  
     }
   if (LastDay==TimeDay(Time[0])) return(0);
   else LastDay=TimeDay(Time[0]);
  
   Quantity();    //             






   if (buy_sell>0) //   
    {
     //    
     total_1=OrdersTotal();
   
     //      
     for(pos_1=0;pos_1<total_1;pos_1++) 
      {
       //     
       if((OrderSelect(pos_1,SELECT_BY_POS,MODE_TRADES)==false)&& OrderSymbol()==Symbol()&& OrderMagicNumber()==Magic) continue;
       
       //    
       if(OrderType()==OP_BUY)
        {
             //         PointInPlus ,    +5
                if(((Open[0]-OrderOpenPrice())>PointInPlus*Point)&&(OrderStopLoss()-OrderOpenPrice()<0))
                 {
                  if(!OrderModify(OrderTicket(),OrderOpenPrice(),(OrderOpenPrice()+5*Point),OrderTakeProfit( ),0,Blue)) //    +5,   
                  {
                   Print("    ",(OrderOpenPrice()+5*Point));
                   //        -  
                   OrderClose(OrderTicket(),Lots,Bid,1,Blue);
                   return(0);
                  }
                 }     
                else
                 {  
//                 Print("------- iBarShift(NULL,0,OrderOpenTime())=",iBarShift(NULL,0,OrderOpenTime())," open[0]=",Open[0]);
                if(iBarShift(NULL,0,OrderOpenTime())>Bar_count-2) //     ,  Bar_count  ,    
                 {
                //       ,    +5
                  if((take5p)&&(Open[1]<OrderOpenPrice()))
                      {
                      OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),(OrderOpenPrice()+5*Point),0,Blue); //    +5
                      }  
                 }
            //   Bars_stop_Count     ,        .
                y=Low[Bars_stop_Count];
                for (x=1;x<=Bars_stop_Count;x++) y=MathMin(y,Low[x]);
                           
                //if((MathMin(Low[1],Low[2])-OrderStopLoss())>0)
                if(y-OrderStopLoss()>0)
                 {
//                  OrderModify(OrderTicket(),OrderOpenPrice(),(MathMin(Low[1],Low[2])-PointInMinus*Point),0,0,Blue); //  
                  OrderModify(OrderTicket(),OrderOpenPrice(),(y-PointInMinus*Point),OrderTakeProfit( ),0,Blue); //  
                 }
                 }  
        } // if(OrderType()==OP_BUY)
///////////////////////////////////////////////////////////////////////////////////////////
       //    
       if(OrderType()==OP_SELL)
        {
             //        PointInPlus   ,    +5 
             if(((OrderOpenPrice()-Close[1])>PointInPlus*Point)&&(OrderOpenPrice()-OrderStopLoss()<0))
              {
              //    +5,   
              if(!OrderModify(OrderTicket(),OrderOpenPrice(),(OrderOpenPrice()-5*Point),OrderTakeProfit( ),0,Red))
               {
                Print("    ",(OrderOpenPrice()-5*Point));
                //        -  
                OrderClose(OrderTicket(),Lots,Ask,1,Red);
                return(0);
               } 
              }
              else
              {                     
              if(iBarShift(NULL,0,OrderOpenTime())>Bar_count-2) //     ,  Bar_count  ,    +5
               {
          //       ,    +5 
                if((take5p)&&(Open[1]>OrderOpenPrice()))
                 {
                  OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),(OrderOpenPrice()-5*Point),0,Red); //    +5
                 }          
               }
         //        . ,        . +PointInMinus 
                y=High[Bars_stop_Count];
                for (x=1;x<=Bars_stop_Count;x++)
                {
                Print("x=",x," High[x]=",High[x]);
                y=MathMax(y,High[x]);
                }           
                
               Print("y=",y," ",(OrderStopLoss()-y)," OrderStopLoss()=",OrderStopLoss());
//              if((OrderStopLoss()-MathMax(High[1],High[2]))>0)
              if((OrderStopLoss()-y)>0)
               {
                OrderModify(OrderTicket(),OrderOpenPrice(),(y+(MarketInfo(Symbol(),MODE_SPREAD)+PointInMinus)*Point),OrderTakeProfit( ),0,Red); //  
//                OrderModify(OrderTicket(),OrderOpenPrice(),(MathMax(High[1],High[2])+(MarketInfo(Symbol(),MODE_SPREAD)+PointInMinus)*Point),0,0,Red); //  
               }
              }
        } // if(OrderType()==OP_SELL)


      } // for(pos_1=0;pos_1<total_1;pos_1++)
    
    } // if (buy_sell>0) //   



   if (buy_sell==0) //    (    ) 
    {
     installation_order();    //     
    }

   return(0);
  }


//+------------------------------------------------------------------+

// ,     
void order_delete()
  {
   //    (  ,  )
   int pos, total; 
   
 
     //    
     total=OrdersTotal();
   
     //      
     for(pos=0;pos<total;pos++) 
      {
       //     
       if((OrderSelect(pos,SELECT_BY_POS,MODE_TRADES)==false)&& OrderSymbol()==Symbol()&& OrderMagicNumber()==Magic) continue;
       
       //      
       if((OrderType()==OP_BUYSTOP)||(OrderType()==OP_SELLSTOP))
        {
         OrderDelete(OrderTicket()); //   
        }
      }
  return(0);
  }


//+------------------------------------------------------------------+

// ,    
void installation_order()
  {
   //    (    )
   int ticket;
   double open_price, cur_Take;
   //  MA
   double MA;

   MA=iMA(NULL,0,PeriodMA,ShiftMA,MODE_EMA,PRICE_CLOSE,1);
   
   //      
   if ((Low[1]<MA)&&(Close[1]>MA))  //       ,    
    {
     if(buy_sell_stop>0)   //    ,   , ..   ,     
      {
       order_delete();    //         
      }     
     if (TakeProfit==0) cur_Take=0;
     else               cur_Take=(open_price+TakeProfit*Point); 
     open_price=(High[1]+MarketInfo(Symbol(),MODE_SPREAD)*Point+5*Point);
     if (StopLoss==0) 
     {
      ticket=OrderSend(Symbol(),OP_BUYSTOP,Lots,open_price,1,(Low[1]-5*Point),cur_Take," - ",Magic,0,Blue);
     }
     else
     {
      ticket=OrderSend(Symbol(),OP_BUYSTOP,Lots,open_price,1,(open_price-StopLoss*Point),cur_Take," - ",Magic,0,Blue);
     } 
     if(ticket<0)
      {
       Print("    #",GetLastError());
      }
     return(0);  
    }
   
   //      
   if ((High[1]>MA)&&(Close[1]<MA))  //       ,    
    {
     if(buy_sell_stop>0)   //    ,   , ..   ,     
      {
       order_delete();    //         
      }     

     open_price=(High[1]+MarketInfo(Symbol(),MODE_SPREAD)*Point+5*Point);
     if (TakeProfit==0) cur_Take=0;
     else               cur_Take=(Low[1]-5*Point-TakeProfit*Point); 

     if (StopLoss==0) 
     {
      Print("open=",(Low[1]-5*Point)," =",open_price," =",cur_Take);
      ticket=OrderSend(Symbol(),OP_SELLSTOP,Lots,(Low[1]-5*Point),1,open_price,cur_Take," - ",Magic,0,Red);
     }
     else
     {
      ticket=OrderSend(Symbol(),OP_SELLSTOP,Lots,(open_price+(StopLoss+MarketInfo(Symbol(),MODE_SPREAD))*Point),1,open_price,cur_Take," - ",Magic,0,Red);
     } 
     if(ticket<0)
      {
       Print("    #",GetLastError());
      }
     return(0);  
    }   
   
  }  




//+------------------------------------------------------------------+
 
//       
void Quantity()
  {
  
   int pos_, total_; //    (  ,  )
  
   //       
   total_=OrdersTotal();
   
   buy_sell_stop=0; //   
   buy_sell=0; //   
   
   //          
   for(pos_=0;pos_<total_;pos_++) 
      {
       //     
       if((OrderSelect(pos_,SELECT_BY_POS,MODE_TRADES)==false)&& OrderSymbol()==Symbol()&& OrderMagicNumber()==Magic) continue;
       
       //      
       if((OrderType()==OP_BUYSTOP)||(OrderType()==OP_SELLSTOP))
        {
         buy_sell_stop=buy_sell_stop+1; //   
        }
       if((OrderType()==OP_BUY)||(OrderType()==OP_SELL))
        {
         buy_sell=buy_sell+1; //   
        }
       
      }  
  
   return(0);
  }
   
   
   
   
   
   
   
   
   
   
   
    
















